#ifndef INCLUDED_COM_SUN_STAR_CHART2_EXPLICITSCALEDATA_HPP
#define INCLUDED_COM_SUN_STAR_CHART2_EXPLICITSCALEDATA_HPP

#include "sal/config.h"

#include "com/sun/star/chart2/ExplicitScaleData.hdl"

#include "com/sun/star/chart2/AxisOrientation.hpp"
#include "com/sun/star/chart2/XScaling.hpp"
#include "com/sun/star/chart2/Break.hpp"
#include "com/sun/star/uno/Reference.hxx"
#include "com/sun/star/uno/Sequence.hxx"
#include "com/sun/star/uno/Type.hxx"
#include "cppu/unotype.hxx"
#include "sal/types.h"
#include "typelib/typeclass.h"
#include "typelib/typedescription.h"

namespace com { namespace sun { namespace star { namespace chart2 {

inline ExplicitScaleData::ExplicitScaleData() SAL_THROW( () )
    : Minimum(0)
    , Maximum(0)
    , Origin(0)
    , Orientation(::com::sun::star::chart2::AxisOrientation_MATHEMATICAL)
    , Scaling()
    , Breaks()
    , AxisType(0)
{
}

inline ExplicitScaleData::ExplicitScaleData(const double& Minimum_, const double& Maximum_, const double& Origin_, const ::com::sun::star::chart2::AxisOrientation& Orientation_, const ::com::sun::star::uno::Reference< ::com::sun::star::chart2::XScaling >& Scaling_, const ::com::sun::star::uno::Sequence< ::com::sun::star::chart2::Break >& Breaks_, const ::sal_Int32& AxisType_) SAL_THROW( () )
    : Minimum(Minimum_)
    , Maximum(Maximum_)
    , Origin(Origin_)
    , Orientation(Orientation_)
    , Scaling(Scaling_)
    , Breaks(Breaks_)
    , AxisType(AxisType_)
{
}

} } } }

namespace com { namespace sun { namespace star { namespace chart2 {

inline ::com::sun::star::uno::Type const & cppu_detail_getUnoType(::com::sun::star::chart2::ExplicitScaleData const *) {
    //TODO: On certain platforms with weak memory models, the following code can result in some threads observing that the_type points to garbage
    static ::typelib_TypeDescriptionReference * the_type = 0;
    if (the_type == 0) {
        ::typelib_static_type_init(&the_type, typelib_TypeClass_STRUCT, "com.sun.star.chart2.ExplicitScaleData");
    }
    return *reinterpret_cast< ::com::sun::star::uno::Type * >(&the_type);
}

} } } }

inline ::com::sun::star::uno::Type const & SAL_CALL getCppuType(::com::sun::star::chart2::ExplicitScaleData const *) SAL_THROW(()) {
    return ::cppu::UnoType< ::com::sun::star::chart2::ExplicitScaleData >::get();
}

#endif // INCLUDED_COM_SUN_STAR_CHART2_EXPLICITSCALEDATA_HPP
